-- Version: 9.0 SP3 9.0.3.6

library ieee;
use ieee.std_logic_1164.all;
library smartfusion;
use smartfusion.all;
library COREAPB3_LIB;
use COREAPB3_LIB.all;
use COREAPB3_LIB.components.all;

entity A2Fxxx_kit_demo is

    port( UART_0_TXD              : out   std_logic;
          UART_0_RXD              : in    std_logic;
          I2C_0_SCL               : inout std_logic := 'Z';
          I2C_0_SDA               : inout std_logic := 'Z';
          MSS_RESET_N             : in    std_logic;
          HallFX1_603             : in    std_logic;
          SDO_262                 : in    std_logic;
          HallFX2_603             : in    std_logic;
          VM262_FPGA              : in    std_logic;
          HallFX3_603             : in    std_logic;
          CUR1_603                : in    std_logic;
          CUR2_603                : in    std_logic;
          CUR3_603                : in    std_logic;
          VM603_FPGA              : in    std_logic;
          VAREF0                  : in    std_logic;
          VAREF1                  : in    std_logic;
          MSSIO_15_CLR_ERR_603    : out   std_logic;
          MSSIO_14_ENABLE_TRI_603 : out   std_logic;
          MSSIO_13_SENSE_HI_603   : out   std_logic;
          MSSIO_12_SAMPLEx_603    : out   std_logic;
          MSSIO_11_SCCLK_603      : out   std_logic;
          MSSIO_10_SDI_262        : out   std_logic;
          MSSIO_9_SCK_262         : out   std_logic;
          MSSIO_8_ENN_262         : out   std_logic;
          MSSIO_7_CLK_262         : out   std_logic;
          MSSIO_5_CSN_262         : out   std_logic;
          MSSIO_3_STEP_262        : out   std_logic;
          MSSIO_1_DIR_262         : out   std_logic;
          BH1_603                 : out   std_logic;
          BH3_603                 : out   std_logic;
          LED3                    : out   std_logic;
          BH2_603                 : out   std_logic;
          BL2_603                 : out   std_logic;
          BL3_603                 : out   std_logic;
          LED1                    : out   std_logic;
          LED4                    : out   std_logic;
          BL1_603                 : out   std_logic;
          LED2                    : out   std_logic;
          HALL3                   : in    std_logic;
          HALL1                   : in    std_logic;
          HALL2                   : in    std_logic;
          PB2                     : in    std_logic;
          PB1                     : in    std_logic;
          OLED_DCN                : out   std_logic
        );

end A2Fxxx_kit_demo;

architecture DEF_ARCH of A2Fxxx_kit_demo is 

  component CoreAPB3
    generic (APBSLOT0ENABLE:integer := 0; 
        APBSLOT10ENABLE:integer := 0; 
        APBSLOT11ENABLE:integer := 0; 
        APBSLOT12ENABLE:integer := 0; 
        APBSLOT13ENABLE:integer := 0; 
        APBSLOT14ENABLE:integer := 0; 
        APBSLOT15ENABLE:integer := 0; APBSLOT1ENABLE:integer := 0; 
        APBSLOT2ENABLE:integer := 0; APBSLOT3ENABLE:integer := 0; 
        APBSLOT4ENABLE:integer := 0; APBSLOT5ENABLE:integer := 0; 
        APBSLOT6ENABLE:integer := 0; APBSLOT7ENABLE:integer := 0; 
        APBSLOT8ENABLE:integer := 0; APBSLOT9ENABLE:integer := 0; 
        APB_DWIDTH:integer := 0; IADDR_ENABLE:integer := 0; 
        RANGESIZE:integer := 0);

    port( PRESETN    : in    std_logic := 'U';
          PCLK       : in    std_logic := 'U';
          PWRITE     : in    std_logic := 'U';
          PENABLE    : in    std_logic := 'U';
          PSEL       : in    std_logic := 'U';
          PREADY     : out   std_logic;
          PSLVERR    : out   std_logic;
          PWRITES    : out   std_logic;
          PENABLES   : out   std_logic;
          PSELS0     : out   std_logic;
          PREADYS0   : in    std_logic := 'U';
          PSLVERRS0  : in    std_logic := 'U';
          PSELS1     : out   std_logic;
          PREADYS1   : in    std_logic := 'U';
          PSLVERRS1  : in    std_logic := 'U';
          PSELS2     : out   std_logic;
          PREADYS2   : in    std_logic := 'U';
          PSLVERRS2  : in    std_logic := 'U';
          PSELS3     : out   std_logic;
          PREADYS3   : in    std_logic := 'U';
          PSLVERRS3  : in    std_logic := 'U';
          PSELS4     : out   std_logic;
          PREADYS4   : in    std_logic := 'U';
          PSLVERRS4  : in    std_logic := 'U';
          PSELS5     : out   std_logic;
          PREADYS5   : in    std_logic := 'U';
          PSLVERRS5  : in    std_logic := 'U';
          PSELS6     : out   std_logic;
          PREADYS6   : in    std_logic := 'U';
          PSLVERRS6  : in    std_logic := 'U';
          PSELS7     : out   std_logic;
          PREADYS7   : in    std_logic := 'U';
          PSLVERRS7  : in    std_logic := 'U';
          PSELS8     : out   std_logic;
          PREADYS8   : in    std_logic := 'U';
          PSLVERRS8  : in    std_logic := 'U';
          PSELS9     : out   std_logic;
          PREADYS9   : in    std_logic := 'U';
          PSLVERRS9  : in    std_logic := 'U';
          PSELS10    : out   std_logic;
          PREADYS10  : in    std_logic := 'U';
          PSLVERRS10 : in    std_logic := 'U';
          PSELS11    : out   std_logic;
          PREADYS11  : in    std_logic := 'U';
          PSLVERRS11 : in    std_logic := 'U';
          PSELS12    : out   std_logic;
          PREADYS12  : in    std_logic := 'U';
          PSLVERRS12 : in    std_logic := 'U';
          PSELS13    : out   std_logic;
          PREADYS13  : in    std_logic := 'U';
          PSLVERRS13 : in    std_logic := 'U';
          PSELS14    : out   std_logic;
          PREADYS14  : in    std_logic := 'U';
          PSLVERRS14 : in    std_logic := 'U';
          PSELS15    : out   std_logic;
          PREADYS15  : in    std_logic := 'U';
          PSLVERRS15 : in    std_logic := 'U';
          PADDR      : in    std_logic_vector(23 downto 0) := (others => 'U');
          PWDATA     : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATA     : out   std_logic_vector(31 downto 0);
          PADDRS     : out   std_logic_vector(23 downto 0);
          PADDRS0    : out   std_logic_vector(23 downto 0);
          PWDATAS    : out   std_logic_vector(31 downto 0);
          PRDATAS0   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS1   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS2   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS3   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS4   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS5   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS6   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS7   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS8   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS9   : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS10  : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS11  : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS12  : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS13  : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS14  : in    std_logic_vector(31 downto 0) := (others => 'U');
          PRDATAS15  : in    std_logic_vector(31 downto 0) := (others => 'U')
        );
  end component;

  component VCC
    port( Y : out   std_logic
        );
  end component;

  component Top_MSS
    port( UART_0_TXD              : out   std_logic;
          UART_0_RXD              : in    std_logic := 'U';
          I2C_0_SCL               : inout   std_logic;
          I2C_0_SDA               : inout   std_logic;
          MSS_RESET_N             : in    std_logic := 'U';
          HallFX1_603             : in    std_logic := 'U';
          SDO_262                 : in    std_logic := 'U';
          HallFX2_603             : in    std_logic := 'U';
          VM262_FPGA              : in    std_logic := 'U';
          HallFX3_603             : in    std_logic := 'U';
          CUR1_603                : in    std_logic := 'U';
          CUR2_603                : in    std_logic := 'U';
          CUR3_603                : in    std_logic := 'U';
          VM603_FPGA              : in    std_logic := 'U';
          LVTTL_HALLFX1           : out   std_logic;
          LVTTL_SDO_262           : out   std_logic;
          LVTTL_HALLFX2           : out   std_logic;
          LVTTL_HALLFX3           : out   std_logic;
          VAREF0                  : in    std_logic := 'U';
          VAREF1                  : in    std_logic := 'U';
          FAB_CLK                 : out   std_logic;
          MSSPSEL                 : out   std_logic;
          MSSPENABLE              : out   std_logic;
          MSSPWRITE               : out   std_logic;
          MSSPREADY               : in    std_logic := 'U';
          MSSPSLVERR              : in    std_logic := 'U';
          MSSIO_15_CLR_ERR_603    : out   std_logic;
          CLR_ERR_603             : in    std_logic := 'U';
          MSSIO_14_ENABLE_TRI_603 : out   std_logic;
          ENABLE_TRI_D_603        : in    std_logic := 'U';
          ENABLE_TRI_E_603        : in    std_logic := 'U';
          MSSIO_13_SENSE_HI_603   : out   std_logic;
          SENSE_HI_603            : in    std_logic := 'U';
          MSSIO_12_SAMPLEx_603    : out   std_logic;
          SAMPLEx_603             : in    std_logic := 'U';
          MSSIO_11_SCCLK_603      : out   std_logic;
          SCCLK_603               : in    std_logic := 'U';
          MSSIO_10_SDI_262        : out   std_logic;
          SDI_262                 : in    std_logic := 'U';
          MSSIO_9_SCK_262         : out   std_logic;
          SCK_262                 : in    std_logic := 'U';
          MSSIO_8_ENN_262         : out   std_logic;
          ENN_262                 : in    std_logic := 'U';
          MSSIO_7_CLK_262         : out   std_logic;
          CLK_262                 : in    std_logic := 'U';
          MSSIO_5_CSN_262         : out   std_logic;
          CSN_262                 : in    std_logic := 'U';
          MSSIO_3_STEP_262        : out   std_logic;
          STEP_262                : in    std_logic := 'U';
          MSSIO_1_DIR_262         : out   std_logic;
          DIR_262                 : in    std_logic := 'U';
          OLED_DCN                : out   std_logic;
          M2F_RESET_N             : out   std_logic;
          MSSPADDR                : out   std_logic_vector(19 downto 0);
          MSSPRDATA               : in    std_logic_vector(31 downto 0) := (others => 'U');
          MSSPWDATA               : out   std_logic_vector(31 downto 0)
        );
  end component;

  component GND
    port( Y : out   std_logic
        );
  end component;

    signal \CoreAPB3_0_APBmslave15_PADDR_[0]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[1]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[2]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[3]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[4]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[5]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[6]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[7]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[8]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[9]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[10]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[11]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[12]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[13]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[14]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[15]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[16]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[17]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[18]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[19]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[20]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[21]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[22]\, 
        \CoreAPB3_0_APBmslave15_PADDR_[23]\, 
        CoreAPB3_0_APBmslave15_PENABLE, 
        \CoreAPB3_0_APBmslave15_PRDATA_[0]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[1]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[2]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[3]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[4]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[5]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[6]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[7]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[8]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[9]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[10]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[11]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[12]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[13]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[14]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[15]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[16]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[17]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[18]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[19]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[20]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[21]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[22]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[23]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[24]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[25]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[26]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[27]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[28]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[29]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[30]\, 
        \CoreAPB3_0_APBmslave15_PRDATA_[31]\, 
        CoreAPB3_0_APBmslave15_PREADY, 
        CoreAPB3_0_APBmslave15_PSELx, 
        CoreAPB3_0_APBmslave15_PSLVERR, 
        \CoreAPB3_0_APBmslave15_PWDATA_[0]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[1]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[2]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[3]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[4]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[5]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[6]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[7]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[8]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[9]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[10]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[11]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[12]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[13]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[14]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[15]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[16]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[17]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[18]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[19]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[20]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[21]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[22]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[23]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[24]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[25]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[26]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[27]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[28]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[29]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[30]\, 
        \CoreAPB3_0_APBmslave15_PWDATA_[31]\, 
        CoreAPB3_0_APBmslave15_PWRITE, tmcm_ac_840_top_0_CLK_262, 
        tmcm_ac_840_top_0_CLR_ERR_603, 
        tmcm_ac_840_top_0_CSN_SPI_262, tmcm_ac_840_top_0_DIR_262, 
        tmcm_ac_840_top_0_ENABLE_TRI_D_603, 
        tmcm_ac_840_top_0_ENABLE_TRI_E_603, 
        tmcm_ac_840_top_0_ENN_262, tmcm_ac_840_top_0_SAMPLEx_603, 
        tmcm_ac_840_top_0_SCCLK_603, 
        tmcm_ac_840_top_0_SCK_SPI_262, 
        tmcm_ac_840_top_0_SDI_SPI_262, 
        tmcm_ac_840_top_0_SENSE_HI_603, 
        tmcm_ac_840_top_0_STEP_262, Top_MSS_0_FAB_CLK, 
        Top_MSS_0_LVTTL_HALLFX1, Top_MSS_0_LVTTL_HALLFX2, 
        Top_MSS_0_LVTTL_HALLFX3, Top_MSS_0_LVTTL_SDO_262, 
        Top_MSS_0_M2F_RESET_N, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[0]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[1]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[2]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[3]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[4]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[5]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[6]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[7]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[8]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[9]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[10]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[11]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[12]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[13]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[14]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[15]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[16]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[17]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[18]\, 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[19]\, 
        Top_MSS_0_MSS_MASTER_APB_PENABLE, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[0]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[1]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[2]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[3]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[4]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[5]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[6]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[7]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[8]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[9]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[10]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[11]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[12]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[13]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[14]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[15]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[16]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[17]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[18]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[19]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[20]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[21]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[22]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[23]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[24]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[25]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[26]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[27]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[28]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[29]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[30]\, 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[31]\, 
        Top_MSS_0_MSS_MASTER_APB_PREADY, 
        Top_MSS_0_MSS_MASTER_APB_PSELx, 
        Top_MSS_0_MSS_MASTER_APB_PSLVERR, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[0]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[1]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[2]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[3]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[4]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[5]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[6]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[7]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[8]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[9]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[10]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[11]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[12]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[13]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[14]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[15]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[16]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[17]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[18]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[19]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[20]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[21]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[22]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[23]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[24]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[25]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[26]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[27]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[28]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[29]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[30]\, 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[31]\, 
        Top_MSS_0_MSS_MASTER_APB_PWRITE, GND_net, VCC_net
         : std_logic;
    signal nc24, nc1, nc8, nc13, nc16, nc19, nc20, nc9, nc22, 
        nc14, nc5, nc21, nc15, nc3, nc10, nc7, nc17, nc4, nc12, 
        nc2, nc23, nc18, nc6, nc11 : std_logic;

begin 


    CoreAPB3_0 : CoreAPB3
      generic map(APBSLOT0ENABLE => 1, APBSLOT10ENABLE => 1,
         APBSLOT11ENABLE => 1, APBSLOT12ENABLE => 1,
         APBSLOT13ENABLE => 1, APBSLOT14ENABLE => 1,
         APBSLOT15ENABLE => 1, APBSLOT1ENABLE => 1,
         APBSLOT2ENABLE => 1, APBSLOT3ENABLE => 1,
         APBSLOT4ENABLE => 1, APBSLOT5ENABLE => 1,
         APBSLOT6ENABLE => 1, APBSLOT7ENABLE => 1,
         APBSLOT8ENABLE => 1, APBSLOT9ENABLE => 1,
         APB_DWIDTH => 32, IADDR_ENABLE => 0, RANGESIZE => 65536
        )

      port map(PRESETN => GND_net, PCLK => GND_net, PWRITE => 
        Top_MSS_0_MSS_MASTER_APB_PWRITE, PENABLE => 
        Top_MSS_0_MSS_MASTER_APB_PENABLE, PSEL => 
        Top_MSS_0_MSS_MASTER_APB_PSELx, PREADY => 
        Top_MSS_0_MSS_MASTER_APB_PREADY, PSLVERR => 
        Top_MSS_0_MSS_MASTER_APB_PSLVERR, PWRITES => 
        CoreAPB3_0_APBmslave15_PWRITE, PENABLES => 
        CoreAPB3_0_APBmslave15_PENABLE, PSELS0 => OPEN, PREADYS0
         => VCC_net, PSLVERRS0 => GND_net, PSELS1 => OPEN, 
        PREADYS1 => VCC_net, PSLVERRS1 => GND_net, PSELS2 => OPEN, 
        PREADYS2 => VCC_net, PSLVERRS2 => GND_net, PSELS3 => OPEN, 
        PREADYS3 => VCC_net, PSLVERRS3 => GND_net, PSELS4 => OPEN, 
        PREADYS4 => VCC_net, PSLVERRS4 => GND_net, PSELS5 => OPEN, 
        PREADYS5 => VCC_net, PSLVERRS5 => GND_net, PSELS6 => OPEN, 
        PREADYS6 => VCC_net, PSLVERRS6 => GND_net, PSELS7 => OPEN, 
        PREADYS7 => VCC_net, PSLVERRS7 => GND_net, PSELS8 => OPEN, 
        PREADYS8 => VCC_net, PSLVERRS8 => GND_net, PSELS9 => OPEN, 
        PREADYS9 => VCC_net, PSLVERRS9 => GND_net, PSELS10 => 
        OPEN, PREADYS10 => VCC_net, PSLVERRS10 => GND_net, 
        PSELS11 => OPEN, PREADYS11 => VCC_net, PSLVERRS11 => 
        GND_net, PSELS12 => OPEN, PREADYS12 => VCC_net, 
        PSLVERRS12 => GND_net, PSELS13 => OPEN, PREADYS13 => 
        VCC_net, PSLVERRS13 => GND_net, PSELS14 => OPEN, 
        PREADYS14 => VCC_net, PSLVERRS14 => GND_net, PSELS15 => 
        CoreAPB3_0_APBmslave15_PSELx, PREADYS15 => 
        CoreAPB3_0_APBmslave15_PREADY, PSLVERRS15 => 
        CoreAPB3_0_APBmslave15_PSLVERR, PADDR(23) => GND_net, 
        PADDR(22) => GND_net, PADDR(21) => GND_net, PADDR(20) => 
        GND_net, PADDR(19) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[19]\, PADDR(18) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[18]\, PADDR(17) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[17]\, PADDR(16) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[16]\, PADDR(15) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[15]\, PADDR(14) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[14]\, PADDR(13) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[13]\, PADDR(12) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[12]\, PADDR(11) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[11]\, PADDR(10) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[10]\, PADDR(9) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[9]\, PADDR(8) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[8]\, PADDR(7) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[7]\, PADDR(6) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[6]\, PADDR(5) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[5]\, PADDR(4) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[4]\, PADDR(3) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[3]\, PADDR(2) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[2]\, PADDR(1) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[1]\, PADDR(0) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[0]\, PWDATA(31) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[31]\, PWDATA(30) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[30]\, PWDATA(29) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[29]\, PWDATA(28) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[28]\, PWDATA(27) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[27]\, PWDATA(26) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[26]\, PWDATA(25) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[25]\, PWDATA(24) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[24]\, PWDATA(23) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[23]\, PWDATA(22) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[22]\, PWDATA(21) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[21]\, PWDATA(20) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[20]\, PWDATA(19) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[19]\, PWDATA(18) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[18]\, PWDATA(17) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[17]\, PWDATA(16) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[16]\, PWDATA(15) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[15]\, PWDATA(14) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[14]\, PWDATA(13) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[13]\, PWDATA(12) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[12]\, PWDATA(11) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[11]\, PWDATA(10) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[10]\, PWDATA(9) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[9]\, PWDATA(8) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[8]\, PWDATA(7) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[7]\, PWDATA(6) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[6]\, PWDATA(5) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[5]\, PWDATA(4) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[4]\, PWDATA(3) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[3]\, PWDATA(2) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[2]\, PWDATA(1) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[1]\, PWDATA(0) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[0]\, PRDATA(31) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[31]\, PRDATA(30) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[30]\, PRDATA(29) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[29]\, PRDATA(28) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[28]\, PRDATA(27) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[27]\, PRDATA(26) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[26]\, PRDATA(25) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[25]\, PRDATA(24) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[24]\, PRDATA(23) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[23]\, PRDATA(22) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[22]\, PRDATA(21) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[21]\, PRDATA(20) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[20]\, PRDATA(19) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[19]\, PRDATA(18) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[18]\, PRDATA(17) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[17]\, PRDATA(16) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[16]\, PRDATA(15) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[15]\, PRDATA(14) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[14]\, PRDATA(13) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[13]\, PRDATA(12) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[12]\, PRDATA(11) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[11]\, PRDATA(10) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[10]\, PRDATA(9) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[9]\, PRDATA(8) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[8]\, PRDATA(7) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[7]\, PRDATA(6) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[6]\, PRDATA(5) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[5]\, PRDATA(4) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[4]\, PRDATA(3) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[3]\, PRDATA(2) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[2]\, PRDATA(1) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[1]\, PRDATA(0) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[0]\, PADDRS(23) => 
        \CoreAPB3_0_APBmslave15_PADDR_[23]\, PADDRS(22) => 
        \CoreAPB3_0_APBmslave15_PADDR_[22]\, PADDRS(21) => 
        \CoreAPB3_0_APBmslave15_PADDR_[21]\, PADDRS(20) => 
        \CoreAPB3_0_APBmslave15_PADDR_[20]\, PADDRS(19) => 
        \CoreAPB3_0_APBmslave15_PADDR_[19]\, PADDRS(18) => 
        \CoreAPB3_0_APBmslave15_PADDR_[18]\, PADDRS(17) => 
        \CoreAPB3_0_APBmslave15_PADDR_[17]\, PADDRS(16) => 
        \CoreAPB3_0_APBmslave15_PADDR_[16]\, PADDRS(15) => 
        \CoreAPB3_0_APBmslave15_PADDR_[15]\, PADDRS(14) => 
        \CoreAPB3_0_APBmslave15_PADDR_[14]\, PADDRS(13) => 
        \CoreAPB3_0_APBmslave15_PADDR_[13]\, PADDRS(12) => 
        \CoreAPB3_0_APBmslave15_PADDR_[12]\, PADDRS(11) => 
        \CoreAPB3_0_APBmslave15_PADDR_[11]\, PADDRS(10) => 
        \CoreAPB3_0_APBmslave15_PADDR_[10]\, PADDRS(9) => 
        \CoreAPB3_0_APBmslave15_PADDR_[9]\, PADDRS(8) => 
        \CoreAPB3_0_APBmslave15_PADDR_[8]\, PADDRS(7) => 
        \CoreAPB3_0_APBmslave15_PADDR_[7]\, PADDRS(6) => 
        \CoreAPB3_0_APBmslave15_PADDR_[6]\, PADDRS(5) => 
        \CoreAPB3_0_APBmslave15_PADDR_[5]\, PADDRS(4) => 
        \CoreAPB3_0_APBmslave15_PADDR_[4]\, PADDRS(3) => 
        \CoreAPB3_0_APBmslave15_PADDR_[3]\, PADDRS(2) => 
        \CoreAPB3_0_APBmslave15_PADDR_[2]\, PADDRS(1) => 
        \CoreAPB3_0_APBmslave15_PADDR_[1]\, PADDRS(0) => 
        \CoreAPB3_0_APBmslave15_PADDR_[0]\, PADDRS0(23) => nc24, 
        PADDRS0(22) => nc1, PADDRS0(21) => nc8, PADDRS0(20) => 
        nc13, PADDRS0(19) => nc16, PADDRS0(18) => nc19, 
        PADDRS0(17) => nc20, PADDRS0(16) => nc9, PADDRS0(15) => 
        nc22, PADDRS0(14) => nc14, PADDRS0(13) => nc5, 
        PADDRS0(12) => nc21, PADDRS0(11) => nc15, PADDRS0(10) => 
        nc3, PADDRS0(9) => nc10, PADDRS0(8) => nc7, PADDRS0(7)
         => nc17, PADDRS0(6) => nc4, PADDRS0(5) => nc12, 
        PADDRS0(4) => nc2, PADDRS0(3) => nc23, PADDRS0(2) => nc18, 
        PADDRS0(1) => nc6, PADDRS0(0) => nc11, PWDATAS(31) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[31]\, PWDATAS(30) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[30]\, PWDATAS(29) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[29]\, PWDATAS(28) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[28]\, PWDATAS(27) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[27]\, PWDATAS(26) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[26]\, PWDATAS(25) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[25]\, PWDATAS(24) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[24]\, PWDATAS(23) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[23]\, PWDATAS(22) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[22]\, PWDATAS(21) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[21]\, PWDATAS(20) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[20]\, PWDATAS(19) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[19]\, PWDATAS(18) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[18]\, PWDATAS(17) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[17]\, PWDATAS(16) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[16]\, PWDATAS(15) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[15]\, PWDATAS(14) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[14]\, PWDATAS(13) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[13]\, PWDATAS(12) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[12]\, PWDATAS(11) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[11]\, PWDATAS(10) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[10]\, PWDATAS(9) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[9]\, PWDATAS(8) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[8]\, PWDATAS(7) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[7]\, PWDATAS(6) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[6]\, PWDATAS(5) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[5]\, PWDATAS(4) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[4]\, PWDATAS(3) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[3]\, PWDATAS(2) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[2]\, PWDATAS(1) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[1]\, PWDATAS(0) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[0]\, PRDATAS0(31) => 
        GND_net, PRDATAS0(30) => GND_net, PRDATAS0(29) => GND_net, 
        PRDATAS0(28) => GND_net, PRDATAS0(27) => GND_net, 
        PRDATAS0(26) => GND_net, PRDATAS0(25) => GND_net, 
        PRDATAS0(24) => GND_net, PRDATAS0(23) => GND_net, 
        PRDATAS0(22) => GND_net, PRDATAS0(21) => GND_net, 
        PRDATAS0(20) => GND_net, PRDATAS0(19) => GND_net, 
        PRDATAS0(18) => GND_net, PRDATAS0(17) => GND_net, 
        PRDATAS0(16) => GND_net, PRDATAS0(15) => GND_net, 
        PRDATAS0(14) => GND_net, PRDATAS0(13) => GND_net, 
        PRDATAS0(12) => GND_net, PRDATAS0(11) => GND_net, 
        PRDATAS0(10) => GND_net, PRDATAS0(9) => GND_net, 
        PRDATAS0(8) => GND_net, PRDATAS0(7) => GND_net, 
        PRDATAS0(6) => GND_net, PRDATAS0(5) => GND_net, 
        PRDATAS0(4) => GND_net, PRDATAS0(3) => GND_net, 
        PRDATAS0(2) => GND_net, PRDATAS0(1) => GND_net, 
        PRDATAS0(0) => GND_net, PRDATAS1(31) => GND_net, 
        PRDATAS1(30) => GND_net, PRDATAS1(29) => GND_net, 
        PRDATAS1(28) => GND_net, PRDATAS1(27) => GND_net, 
        PRDATAS1(26) => GND_net, PRDATAS1(25) => GND_net, 
        PRDATAS1(24) => GND_net, PRDATAS1(23) => GND_net, 
        PRDATAS1(22) => GND_net, PRDATAS1(21) => GND_net, 
        PRDATAS1(20) => GND_net, PRDATAS1(19) => GND_net, 
        PRDATAS1(18) => GND_net, PRDATAS1(17) => GND_net, 
        PRDATAS1(16) => GND_net, PRDATAS1(15) => GND_net, 
        PRDATAS1(14) => GND_net, PRDATAS1(13) => GND_net, 
        PRDATAS1(12) => GND_net, PRDATAS1(11) => GND_net, 
        PRDATAS1(10) => GND_net, PRDATAS1(9) => GND_net, 
        PRDATAS1(8) => GND_net, PRDATAS1(7) => GND_net, 
        PRDATAS1(6) => GND_net, PRDATAS1(5) => GND_net, 
        PRDATAS1(4) => GND_net, PRDATAS1(3) => GND_net, 
        PRDATAS1(2) => GND_net, PRDATAS1(1) => GND_net, 
        PRDATAS1(0) => GND_net, PRDATAS2(31) => GND_net, 
        PRDATAS2(30) => GND_net, PRDATAS2(29) => GND_net, 
        PRDATAS2(28) => GND_net, PRDATAS2(27) => GND_net, 
        PRDATAS2(26) => GND_net, PRDATAS2(25) => GND_net, 
        PRDATAS2(24) => GND_net, PRDATAS2(23) => GND_net, 
        PRDATAS2(22) => GND_net, PRDATAS2(21) => GND_net, 
        PRDATAS2(20) => GND_net, PRDATAS2(19) => GND_net, 
        PRDATAS2(18) => GND_net, PRDATAS2(17) => GND_net, 
        PRDATAS2(16) => GND_net, PRDATAS2(15) => GND_net, 
        PRDATAS2(14) => GND_net, PRDATAS2(13) => GND_net, 
        PRDATAS2(12) => GND_net, PRDATAS2(11) => GND_net, 
        PRDATAS2(10) => GND_net, PRDATAS2(9) => GND_net, 
        PRDATAS2(8) => GND_net, PRDATAS2(7) => GND_net, 
        PRDATAS2(6) => GND_net, PRDATAS2(5) => GND_net, 
        PRDATAS2(4) => GND_net, PRDATAS2(3) => GND_net, 
        PRDATAS2(2) => GND_net, PRDATAS2(1) => GND_net, 
        PRDATAS2(0) => GND_net, PRDATAS3(31) => GND_net, 
        PRDATAS3(30) => GND_net, PRDATAS3(29) => GND_net, 
        PRDATAS3(28) => GND_net, PRDATAS3(27) => GND_net, 
        PRDATAS3(26) => GND_net, PRDATAS3(25) => GND_net, 
        PRDATAS3(24) => GND_net, PRDATAS3(23) => GND_net, 
        PRDATAS3(22) => GND_net, PRDATAS3(21) => GND_net, 
        PRDATAS3(20) => GND_net, PRDATAS3(19) => GND_net, 
        PRDATAS3(18) => GND_net, PRDATAS3(17) => GND_net, 
        PRDATAS3(16) => GND_net, PRDATAS3(15) => GND_net, 
        PRDATAS3(14) => GND_net, PRDATAS3(13) => GND_net, 
        PRDATAS3(12) => GND_net, PRDATAS3(11) => GND_net, 
        PRDATAS3(10) => GND_net, PRDATAS3(9) => GND_net, 
        PRDATAS3(8) => GND_net, PRDATAS3(7) => GND_net, 
        PRDATAS3(6) => GND_net, PRDATAS3(5) => GND_net, 
        PRDATAS3(4) => GND_net, PRDATAS3(3) => GND_net, 
        PRDATAS3(2) => GND_net, PRDATAS3(1) => GND_net, 
        PRDATAS3(0) => GND_net, PRDATAS4(31) => GND_net, 
        PRDATAS4(30) => GND_net, PRDATAS4(29) => GND_net, 
        PRDATAS4(28) => GND_net, PRDATAS4(27) => GND_net, 
        PRDATAS4(26) => GND_net, PRDATAS4(25) => GND_net, 
        PRDATAS4(24) => GND_net, PRDATAS4(23) => GND_net, 
        PRDATAS4(22) => GND_net, PRDATAS4(21) => GND_net, 
        PRDATAS4(20) => GND_net, PRDATAS4(19) => GND_net, 
        PRDATAS4(18) => GND_net, PRDATAS4(17) => GND_net, 
        PRDATAS4(16) => GND_net, PRDATAS4(15) => GND_net, 
        PRDATAS4(14) => GND_net, PRDATAS4(13) => GND_net, 
        PRDATAS4(12) => GND_net, PRDATAS4(11) => GND_net, 
        PRDATAS4(10) => GND_net, PRDATAS4(9) => GND_net, 
        PRDATAS4(8) => GND_net, PRDATAS4(7) => GND_net, 
        PRDATAS4(6) => GND_net, PRDATAS4(5) => GND_net, 
        PRDATAS4(4) => GND_net, PRDATAS4(3) => GND_net, 
        PRDATAS4(2) => GND_net, PRDATAS4(1) => GND_net, 
        PRDATAS4(0) => GND_net, PRDATAS5(31) => GND_net, 
        PRDATAS5(30) => GND_net, PRDATAS5(29) => GND_net, 
        PRDATAS5(28) => GND_net, PRDATAS5(27) => GND_net, 
        PRDATAS5(26) => GND_net, PRDATAS5(25) => GND_net, 
        PRDATAS5(24) => GND_net, PRDATAS5(23) => GND_net, 
        PRDATAS5(22) => GND_net, PRDATAS5(21) => GND_net, 
        PRDATAS5(20) => GND_net, PRDATAS5(19) => GND_net, 
        PRDATAS5(18) => GND_net, PRDATAS5(17) => GND_net, 
        PRDATAS5(16) => GND_net, PRDATAS5(15) => GND_net, 
        PRDATAS5(14) => GND_net, PRDATAS5(13) => GND_net, 
        PRDATAS5(12) => GND_net, PRDATAS5(11) => GND_net, 
        PRDATAS5(10) => GND_net, PRDATAS5(9) => GND_net, 
        PRDATAS5(8) => GND_net, PRDATAS5(7) => GND_net, 
        PRDATAS5(6) => GND_net, PRDATAS5(5) => GND_net, 
        PRDATAS5(4) => GND_net, PRDATAS5(3) => GND_net, 
        PRDATAS5(2) => GND_net, PRDATAS5(1) => GND_net, 
        PRDATAS5(0) => GND_net, PRDATAS6(31) => GND_net, 
        PRDATAS6(30) => GND_net, PRDATAS6(29) => GND_net, 
        PRDATAS6(28) => GND_net, PRDATAS6(27) => GND_net, 
        PRDATAS6(26) => GND_net, PRDATAS6(25) => GND_net, 
        PRDATAS6(24) => GND_net, PRDATAS6(23) => GND_net, 
        PRDATAS6(22) => GND_net, PRDATAS6(21) => GND_net, 
        PRDATAS6(20) => GND_net, PRDATAS6(19) => GND_net, 
        PRDATAS6(18) => GND_net, PRDATAS6(17) => GND_net, 
        PRDATAS6(16) => GND_net, PRDATAS6(15) => GND_net, 
        PRDATAS6(14) => GND_net, PRDATAS6(13) => GND_net, 
        PRDATAS6(12) => GND_net, PRDATAS6(11) => GND_net, 
        PRDATAS6(10) => GND_net, PRDATAS6(9) => GND_net, 
        PRDATAS6(8) => GND_net, PRDATAS6(7) => GND_net, 
        PRDATAS6(6) => GND_net, PRDATAS6(5) => GND_net, 
        PRDATAS6(4) => GND_net, PRDATAS6(3) => GND_net, 
        PRDATAS6(2) => GND_net, PRDATAS6(1) => GND_net, 
        PRDATAS6(0) => GND_net, PRDATAS7(31) => GND_net, 
        PRDATAS7(30) => GND_net, PRDATAS7(29) => GND_net, 
        PRDATAS7(28) => GND_net, PRDATAS7(27) => GND_net, 
        PRDATAS7(26) => GND_net, PRDATAS7(25) => GND_net, 
        PRDATAS7(24) => GND_net, PRDATAS7(23) => GND_net, 
        PRDATAS7(22) => GND_net, PRDATAS7(21) => GND_net, 
        PRDATAS7(20) => GND_net, PRDATAS7(19) => GND_net, 
        PRDATAS7(18) => GND_net, PRDATAS7(17) => GND_net, 
        PRDATAS7(16) => GND_net, PRDATAS7(15) => GND_net, 
        PRDATAS7(14) => GND_net, PRDATAS7(13) => GND_net, 
        PRDATAS7(12) => GND_net, PRDATAS7(11) => GND_net, 
        PRDATAS7(10) => GND_net, PRDATAS7(9) => GND_net, 
        PRDATAS7(8) => GND_net, PRDATAS7(7) => GND_net, 
        PRDATAS7(6) => GND_net, PRDATAS7(5) => GND_net, 
        PRDATAS7(4) => GND_net, PRDATAS7(3) => GND_net, 
        PRDATAS7(2) => GND_net, PRDATAS7(1) => GND_net, 
        PRDATAS7(0) => GND_net, PRDATAS8(31) => GND_net, 
        PRDATAS8(30) => GND_net, PRDATAS8(29) => GND_net, 
        PRDATAS8(28) => GND_net, PRDATAS8(27) => GND_net, 
        PRDATAS8(26) => GND_net, PRDATAS8(25) => GND_net, 
        PRDATAS8(24) => GND_net, PRDATAS8(23) => GND_net, 
        PRDATAS8(22) => GND_net, PRDATAS8(21) => GND_net, 
        PRDATAS8(20) => GND_net, PRDATAS8(19) => GND_net, 
        PRDATAS8(18) => GND_net, PRDATAS8(17) => GND_net, 
        PRDATAS8(16) => GND_net, PRDATAS8(15) => GND_net, 
        PRDATAS8(14) => GND_net, PRDATAS8(13) => GND_net, 
        PRDATAS8(12) => GND_net, PRDATAS8(11) => GND_net, 
        PRDATAS8(10) => GND_net, PRDATAS8(9) => GND_net, 
        PRDATAS8(8) => GND_net, PRDATAS8(7) => GND_net, 
        PRDATAS8(6) => GND_net, PRDATAS8(5) => GND_net, 
        PRDATAS8(4) => GND_net, PRDATAS8(3) => GND_net, 
        PRDATAS8(2) => GND_net, PRDATAS8(1) => GND_net, 
        PRDATAS8(0) => GND_net, PRDATAS9(31) => GND_net, 
        PRDATAS9(30) => GND_net, PRDATAS9(29) => GND_net, 
        PRDATAS9(28) => GND_net, PRDATAS9(27) => GND_net, 
        PRDATAS9(26) => GND_net, PRDATAS9(25) => GND_net, 
        PRDATAS9(24) => GND_net, PRDATAS9(23) => GND_net, 
        PRDATAS9(22) => GND_net, PRDATAS9(21) => GND_net, 
        PRDATAS9(20) => GND_net, PRDATAS9(19) => GND_net, 
        PRDATAS9(18) => GND_net, PRDATAS9(17) => GND_net, 
        PRDATAS9(16) => GND_net, PRDATAS9(15) => GND_net, 
        PRDATAS9(14) => GND_net, PRDATAS9(13) => GND_net, 
        PRDATAS9(12) => GND_net, PRDATAS9(11) => GND_net, 
        PRDATAS9(10) => GND_net, PRDATAS9(9) => GND_net, 
        PRDATAS9(8) => GND_net, PRDATAS9(7) => GND_net, 
        PRDATAS9(6) => GND_net, PRDATAS9(5) => GND_net, 
        PRDATAS9(4) => GND_net, PRDATAS9(3) => GND_net, 
        PRDATAS9(2) => GND_net, PRDATAS9(1) => GND_net, 
        PRDATAS9(0) => GND_net, PRDATAS10(31) => GND_net, 
        PRDATAS10(30) => GND_net, PRDATAS10(29) => GND_net, 
        PRDATAS10(28) => GND_net, PRDATAS10(27) => GND_net, 
        PRDATAS10(26) => GND_net, PRDATAS10(25) => GND_net, 
        PRDATAS10(24) => GND_net, PRDATAS10(23) => GND_net, 
        PRDATAS10(22) => GND_net, PRDATAS10(21) => GND_net, 
        PRDATAS10(20) => GND_net, PRDATAS10(19) => GND_net, 
        PRDATAS10(18) => GND_net, PRDATAS10(17) => GND_net, 
        PRDATAS10(16) => GND_net, PRDATAS10(15) => GND_net, 
        PRDATAS10(14) => GND_net, PRDATAS10(13) => GND_net, 
        PRDATAS10(12) => GND_net, PRDATAS10(11) => GND_net, 
        PRDATAS10(10) => GND_net, PRDATAS10(9) => GND_net, 
        PRDATAS10(8) => GND_net, PRDATAS10(7) => GND_net, 
        PRDATAS10(6) => GND_net, PRDATAS10(5) => GND_net, 
        PRDATAS10(4) => GND_net, PRDATAS10(3) => GND_net, 
        PRDATAS10(2) => GND_net, PRDATAS10(1) => GND_net, 
        PRDATAS10(0) => GND_net, PRDATAS11(31) => GND_net, 
        PRDATAS11(30) => GND_net, PRDATAS11(29) => GND_net, 
        PRDATAS11(28) => GND_net, PRDATAS11(27) => GND_net, 
        PRDATAS11(26) => GND_net, PRDATAS11(25) => GND_net, 
        PRDATAS11(24) => GND_net, PRDATAS11(23) => GND_net, 
        PRDATAS11(22) => GND_net, PRDATAS11(21) => GND_net, 
        PRDATAS11(20) => GND_net, PRDATAS11(19) => GND_net, 
        PRDATAS11(18) => GND_net, PRDATAS11(17) => GND_net, 
        PRDATAS11(16) => GND_net, PRDATAS11(15) => GND_net, 
        PRDATAS11(14) => GND_net, PRDATAS11(13) => GND_net, 
        PRDATAS11(12) => GND_net, PRDATAS11(11) => GND_net, 
        PRDATAS11(10) => GND_net, PRDATAS11(9) => GND_net, 
        PRDATAS11(8) => GND_net, PRDATAS11(7) => GND_net, 
        PRDATAS11(6) => GND_net, PRDATAS11(5) => GND_net, 
        PRDATAS11(4) => GND_net, PRDATAS11(3) => GND_net, 
        PRDATAS11(2) => GND_net, PRDATAS11(1) => GND_net, 
        PRDATAS11(0) => GND_net, PRDATAS12(31) => GND_net, 
        PRDATAS12(30) => GND_net, PRDATAS12(29) => GND_net, 
        PRDATAS12(28) => GND_net, PRDATAS12(27) => GND_net, 
        PRDATAS12(26) => GND_net, PRDATAS12(25) => GND_net, 
        PRDATAS12(24) => GND_net, PRDATAS12(23) => GND_net, 
        PRDATAS12(22) => GND_net, PRDATAS12(21) => GND_net, 
        PRDATAS12(20) => GND_net, PRDATAS12(19) => GND_net, 
        PRDATAS12(18) => GND_net, PRDATAS12(17) => GND_net, 
        PRDATAS12(16) => GND_net, PRDATAS12(15) => GND_net, 
        PRDATAS12(14) => GND_net, PRDATAS12(13) => GND_net, 
        PRDATAS12(12) => GND_net, PRDATAS12(11) => GND_net, 
        PRDATAS12(10) => GND_net, PRDATAS12(9) => GND_net, 
        PRDATAS12(8) => GND_net, PRDATAS12(7) => GND_net, 
        PRDATAS12(6) => GND_net, PRDATAS12(5) => GND_net, 
        PRDATAS12(4) => GND_net, PRDATAS12(3) => GND_net, 
        PRDATAS12(2) => GND_net, PRDATAS12(1) => GND_net, 
        PRDATAS12(0) => GND_net, PRDATAS13(31) => GND_net, 
        PRDATAS13(30) => GND_net, PRDATAS13(29) => GND_net, 
        PRDATAS13(28) => GND_net, PRDATAS13(27) => GND_net, 
        PRDATAS13(26) => GND_net, PRDATAS13(25) => GND_net, 
        PRDATAS13(24) => GND_net, PRDATAS13(23) => GND_net, 
        PRDATAS13(22) => GND_net, PRDATAS13(21) => GND_net, 
        PRDATAS13(20) => GND_net, PRDATAS13(19) => GND_net, 
        PRDATAS13(18) => GND_net, PRDATAS13(17) => GND_net, 
        PRDATAS13(16) => GND_net, PRDATAS13(15) => GND_net, 
        PRDATAS13(14) => GND_net, PRDATAS13(13) => GND_net, 
        PRDATAS13(12) => GND_net, PRDATAS13(11) => GND_net, 
        PRDATAS13(10) => GND_net, PRDATAS13(9) => GND_net, 
        PRDATAS13(8) => GND_net, PRDATAS13(7) => GND_net, 
        PRDATAS13(6) => GND_net, PRDATAS13(5) => GND_net, 
        PRDATAS13(4) => GND_net, PRDATAS13(3) => GND_net, 
        PRDATAS13(2) => GND_net, PRDATAS13(1) => GND_net, 
        PRDATAS13(0) => GND_net, PRDATAS14(31) => GND_net, 
        PRDATAS14(30) => GND_net, PRDATAS14(29) => GND_net, 
        PRDATAS14(28) => GND_net, PRDATAS14(27) => GND_net, 
        PRDATAS14(26) => GND_net, PRDATAS14(25) => GND_net, 
        PRDATAS14(24) => GND_net, PRDATAS14(23) => GND_net, 
        PRDATAS14(22) => GND_net, PRDATAS14(21) => GND_net, 
        PRDATAS14(20) => GND_net, PRDATAS14(19) => GND_net, 
        PRDATAS14(18) => GND_net, PRDATAS14(17) => GND_net, 
        PRDATAS14(16) => GND_net, PRDATAS14(15) => GND_net, 
        PRDATAS14(14) => GND_net, PRDATAS14(13) => GND_net, 
        PRDATAS14(12) => GND_net, PRDATAS14(11) => GND_net, 
        PRDATAS14(10) => GND_net, PRDATAS14(9) => GND_net, 
        PRDATAS14(8) => GND_net, PRDATAS14(7) => GND_net, 
        PRDATAS14(6) => GND_net, PRDATAS14(5) => GND_net, 
        PRDATAS14(4) => GND_net, PRDATAS14(3) => GND_net, 
        PRDATAS14(2) => GND_net, PRDATAS14(1) => GND_net, 
        PRDATAS14(0) => GND_net, PRDATAS15(31) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[31]\, PRDATAS15(30) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[30]\, PRDATAS15(29) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[29]\, PRDATAS15(28) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[28]\, PRDATAS15(27) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[27]\, PRDATAS15(26) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[26]\, PRDATAS15(25) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[25]\, PRDATAS15(24) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[24]\, PRDATAS15(23) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[23]\, PRDATAS15(22) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[22]\, PRDATAS15(21) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[21]\, PRDATAS15(20) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[20]\, PRDATAS15(19) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[19]\, PRDATAS15(18) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[18]\, PRDATAS15(17) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[17]\, PRDATAS15(16) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[16]\, PRDATAS15(15) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[15]\, PRDATAS15(14) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[14]\, PRDATAS15(13) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[13]\, PRDATAS15(12) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[12]\, PRDATAS15(11) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[11]\, PRDATAS15(10) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[10]\, PRDATAS15(9) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[9]\, PRDATAS15(8) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[8]\, PRDATAS15(7) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[7]\, PRDATAS15(6) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[6]\, PRDATAS15(5) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[5]\, PRDATAS15(4) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[4]\, PRDATAS15(3) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[3]\, PRDATAS15(2) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[2]\, PRDATAS15(1) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[1]\, PRDATAS15(0) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[0]\);
    
    \VCC\ : VCC
      port map(Y => VCC_net);
    
    Top_MSS_0 : Top_MSS
      port map(UART_0_TXD => UART_0_TXD, UART_0_RXD => UART_0_RXD, 
        I2C_0_SCL => I2C_0_SCL, I2C_0_SDA => I2C_0_SDA, 
        MSS_RESET_N => MSS_RESET_N, HallFX1_603 => HallFX1_603, 
        SDO_262 => SDO_262, HallFX2_603 => HallFX2_603, 
        VM262_FPGA => VM262_FPGA, HallFX3_603 => HallFX3_603, 
        CUR1_603 => CUR1_603, CUR2_603 => CUR2_603, CUR3_603 => 
        CUR3_603, VM603_FPGA => VM603_FPGA, LVTTL_HALLFX1 => 
        Top_MSS_0_LVTTL_HALLFX1, LVTTL_SDO_262 => 
        Top_MSS_0_LVTTL_SDO_262, LVTTL_HALLFX2 => 
        Top_MSS_0_LVTTL_HALLFX2, LVTTL_HALLFX3 => 
        Top_MSS_0_LVTTL_HALLFX3, VAREF0 => VAREF0, VAREF1 => 
        VAREF1, FAB_CLK => Top_MSS_0_FAB_CLK, MSSPSEL => 
        Top_MSS_0_MSS_MASTER_APB_PSELx, MSSPENABLE => 
        Top_MSS_0_MSS_MASTER_APB_PENABLE, MSSPWRITE => 
        Top_MSS_0_MSS_MASTER_APB_PWRITE, MSSPREADY => 
        Top_MSS_0_MSS_MASTER_APB_PREADY, MSSPSLVERR => 
        Top_MSS_0_MSS_MASTER_APB_PSLVERR, MSSIO_15_CLR_ERR_603
         => MSSIO_15_CLR_ERR_603, CLR_ERR_603 => 
        tmcm_ac_840_top_0_CLR_ERR_603, MSSIO_14_ENABLE_TRI_603
         => MSSIO_14_ENABLE_TRI_603, ENABLE_TRI_D_603 => 
        tmcm_ac_840_top_0_ENABLE_TRI_D_603, ENABLE_TRI_E_603 => 
        tmcm_ac_840_top_0_ENABLE_TRI_E_603, MSSIO_13_SENSE_HI_603
         => MSSIO_13_SENSE_HI_603, SENSE_HI_603 => 
        tmcm_ac_840_top_0_SENSE_HI_603, MSSIO_12_SAMPLEx_603 => 
        MSSIO_12_SAMPLEx_603, SAMPLEx_603 => 
        tmcm_ac_840_top_0_SAMPLEx_603, MSSIO_11_SCCLK_603 => 
        MSSIO_11_SCCLK_603, SCCLK_603 => 
        tmcm_ac_840_top_0_SCCLK_603, MSSIO_10_SDI_262 => 
        MSSIO_10_SDI_262, SDI_262 => 
        tmcm_ac_840_top_0_SDI_SPI_262, MSSIO_9_SCK_262 => 
        MSSIO_9_SCK_262, SCK_262 => tmcm_ac_840_top_0_SCK_SPI_262, 
        MSSIO_8_ENN_262 => MSSIO_8_ENN_262, ENN_262 => 
        tmcm_ac_840_top_0_ENN_262, MSSIO_7_CLK_262 => 
        MSSIO_7_CLK_262, CLK_262 => tmcm_ac_840_top_0_CLK_262, 
        MSSIO_5_CSN_262 => MSSIO_5_CSN_262, CSN_262 => 
        tmcm_ac_840_top_0_CSN_SPI_262, MSSIO_3_STEP_262 => 
        MSSIO_3_STEP_262, STEP_262 => tmcm_ac_840_top_0_STEP_262, 
        MSSIO_1_DIR_262 => MSSIO_1_DIR_262, DIR_262 => 
        tmcm_ac_840_top_0_DIR_262, OLED_DCN => OLED_DCN, 
        M2F_RESET_N => Top_MSS_0_M2F_RESET_N, MSSPADDR(19) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[19]\, MSSPADDR(18) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[18]\, MSSPADDR(17) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[17]\, MSSPADDR(16) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[16]\, MSSPADDR(15) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[15]\, MSSPADDR(14) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[14]\, MSSPADDR(13) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[13]\, MSSPADDR(12) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[12]\, MSSPADDR(11) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[11]\, MSSPADDR(10) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[10]\, MSSPADDR(9) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[9]\, MSSPADDR(8) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[8]\, MSSPADDR(7) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[7]\, MSSPADDR(6) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[6]\, MSSPADDR(5) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[5]\, MSSPADDR(4) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[4]\, MSSPADDR(3) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[3]\, MSSPADDR(2) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[2]\, MSSPADDR(1) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[1]\, MSSPADDR(0) => 
        \Top_MSS_0_MSS_MASTER_APB_PADDR_[0]\, MSSPRDATA(31) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[31]\, MSSPRDATA(30) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[30]\, MSSPRDATA(29) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[29]\, MSSPRDATA(28) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[28]\, MSSPRDATA(27) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[27]\, MSSPRDATA(26) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[26]\, MSSPRDATA(25) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[25]\, MSSPRDATA(24) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[24]\, MSSPRDATA(23) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[23]\, MSSPRDATA(22) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[22]\, MSSPRDATA(21) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[21]\, MSSPRDATA(20) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[20]\, MSSPRDATA(19) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[19]\, MSSPRDATA(18) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[18]\, MSSPRDATA(17) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[17]\, MSSPRDATA(16) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[16]\, MSSPRDATA(15) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[15]\, MSSPRDATA(14) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[14]\, MSSPRDATA(13) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[13]\, MSSPRDATA(12) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[12]\, MSSPRDATA(11) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[11]\, MSSPRDATA(10) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[10]\, MSSPRDATA(9) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[9]\, MSSPRDATA(8) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[8]\, MSSPRDATA(7) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[7]\, MSSPRDATA(6) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[6]\, MSSPRDATA(5) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[5]\, MSSPRDATA(4) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[4]\, MSSPRDATA(3) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[3]\, MSSPRDATA(2) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[2]\, MSSPRDATA(1) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[1]\, MSSPRDATA(0) => 
        \Top_MSS_0_MSS_MASTER_APB_PRDATA_[0]\, MSSPWDATA(31) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[31]\, MSSPWDATA(30) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[30]\, MSSPWDATA(29) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[29]\, MSSPWDATA(28) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[28]\, MSSPWDATA(27) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[27]\, MSSPWDATA(26) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[26]\, MSSPWDATA(25) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[25]\, MSSPWDATA(24) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[24]\, MSSPWDATA(23) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[23]\, MSSPWDATA(22) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[22]\, MSSPWDATA(21) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[21]\, MSSPWDATA(20) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[20]\, MSSPWDATA(19) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[19]\, MSSPWDATA(18) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[18]\, MSSPWDATA(17) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[17]\, MSSPWDATA(16) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[16]\, MSSPWDATA(15) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[15]\, MSSPWDATA(14) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[14]\, MSSPWDATA(13) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[13]\, MSSPWDATA(12) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[12]\, MSSPWDATA(11) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[11]\, MSSPWDATA(10) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[10]\, MSSPWDATA(9) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[9]\, MSSPWDATA(8) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[8]\, MSSPWDATA(7) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[7]\, MSSPWDATA(6) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[6]\, MSSPWDATA(5) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[5]\, MSSPWDATA(4) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[4]\, MSSPWDATA(3) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[3]\, MSSPWDATA(2) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[2]\, MSSPWDATA(1) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[1]\, MSSPWDATA(0) => 
        \Top_MSS_0_MSS_MASTER_APB_PWDATA_[0]\);
    
    \GND\ : GND
      port map(Y => GND_net);
    
    tmcm_ac_840_top_0 : entity work.tmcm_ac_840_top
      port map(FABCLK => Top_MSS_0_FAB_CLK, PRESETn => 
        Top_MSS_0_M2F_RESET_N, LED1 => LED1, LED2 => LED2, LED3
         => LED3, LED4 => LED4, PB1 => PB1, PB2 => PB2, BL1_603
         => BL1_603, BH1_603 => BH1_603, BH2_603 => BH2_603, 
        BL2_603 => BL2_603, BH3_603 => BH3_603, BL3_603 => 
        BL3_603, HALLFX1_603 => Top_MSS_0_LVTTL_HALLFX1, 
        HALLFX2_603 => Top_MSS_0_LVTTL_HALLFX2, HALLFX3_603 => 
        Top_MSS_0_LVTTL_HALLFX3, ENABLE_TRI_D_603 => 
        tmcm_ac_840_top_0_ENABLE_TRI_D_603, ENABLE_TRI_E_603 => 
        tmcm_ac_840_top_0_ENABLE_TRI_E_603, SAMPLEx_603 => 
        tmcm_ac_840_top_0_SAMPLEx_603, SENSE_HI_603 => 
        tmcm_ac_840_top_0_SENSE_HI_603, SCCLK_603 => 
        tmcm_ac_840_top_0_SCCLK_603, CLR_ERR_603 => 
        tmcm_ac_840_top_0_CLR_ERR_603, CLK_262 => 
        tmcm_ac_840_top_0_CLK_262, SCK_SPI_262 => 
        tmcm_ac_840_top_0_SCK_SPI_262, CSN_SPI_262 => 
        tmcm_ac_840_top_0_CSN_SPI_262, SDO_SPI_262 => 
        Top_MSS_0_LVTTL_SDO_262, SDI_SPI_262 => 
        tmcm_ac_840_top_0_SDI_SPI_262, DIR_262 => 
        tmcm_ac_840_top_0_DIR_262, STEP_262 => 
        tmcm_ac_840_top_0_STEP_262, SG_TST_262 => GND_net, 
        ENN_262 => tmcm_ac_840_top_0_ENN_262, ENC_A => GND_net, 
        ENC_B => GND_net, ENC_N => GND_net, HALL1 => HALL1, HALL2
         => HALL2, HALL3 => HALL3, PENABLE => 
        CoreAPB3_0_APBmslave15_PENABLE, PSEL => 
        CoreAPB3_0_APBmslave15_PSELx, PWRITE => 
        CoreAPB3_0_APBmslave15_PWRITE, PREADY => 
        CoreAPB3_0_APBmslave15_PREADY, PSLVERR => 
        CoreAPB3_0_APBmslave15_PSLVERR, PADDR(23) => 
        \CoreAPB3_0_APBmslave15_PADDR_[23]\, PADDR(22) => 
        \CoreAPB3_0_APBmslave15_PADDR_[22]\, PADDR(21) => 
        \CoreAPB3_0_APBmslave15_PADDR_[21]\, PADDR(20) => 
        \CoreAPB3_0_APBmslave15_PADDR_[20]\, PADDR(19) => 
        \CoreAPB3_0_APBmslave15_PADDR_[19]\, PADDR(18) => 
        \CoreAPB3_0_APBmslave15_PADDR_[18]\, PADDR(17) => 
        \CoreAPB3_0_APBmslave15_PADDR_[17]\, PADDR(16) => 
        \CoreAPB3_0_APBmslave15_PADDR_[16]\, PADDR(15) => 
        \CoreAPB3_0_APBmslave15_PADDR_[15]\, PADDR(14) => 
        \CoreAPB3_0_APBmslave15_PADDR_[14]\, PADDR(13) => 
        \CoreAPB3_0_APBmslave15_PADDR_[13]\, PADDR(12) => 
        \CoreAPB3_0_APBmslave15_PADDR_[12]\, PADDR(11) => 
        \CoreAPB3_0_APBmslave15_PADDR_[11]\, PADDR(10) => 
        \CoreAPB3_0_APBmslave15_PADDR_[10]\, PADDR(9) => 
        \CoreAPB3_0_APBmslave15_PADDR_[9]\, PADDR(8) => 
        \CoreAPB3_0_APBmslave15_PADDR_[8]\, PADDR(7) => 
        \CoreAPB3_0_APBmslave15_PADDR_[7]\, PADDR(6) => 
        \CoreAPB3_0_APBmslave15_PADDR_[6]\, PADDR(5) => 
        \CoreAPB3_0_APBmslave15_PADDR_[5]\, PADDR(4) => 
        \CoreAPB3_0_APBmslave15_PADDR_[4]\, PADDR(3) => 
        \CoreAPB3_0_APBmslave15_PADDR_[3]\, PADDR(2) => 
        \CoreAPB3_0_APBmslave15_PADDR_[2]\, PADDR(1) => 
        \CoreAPB3_0_APBmslave15_PADDR_[1]\, PADDR(0) => 
        \CoreAPB3_0_APBmslave15_PADDR_[0]\, PWDATA(31) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[31]\, PWDATA(30) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[30]\, PWDATA(29) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[29]\, PWDATA(28) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[28]\, PWDATA(27) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[27]\, PWDATA(26) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[26]\, PWDATA(25) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[25]\, PWDATA(24) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[24]\, PWDATA(23) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[23]\, PWDATA(22) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[22]\, PWDATA(21) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[21]\, PWDATA(20) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[20]\, PWDATA(19) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[19]\, PWDATA(18) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[18]\, PWDATA(17) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[17]\, PWDATA(16) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[16]\, PWDATA(15) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[15]\, PWDATA(14) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[14]\, PWDATA(13) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[13]\, PWDATA(12) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[12]\, PWDATA(11) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[11]\, PWDATA(10) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[10]\, PWDATA(9) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[9]\, PWDATA(8) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[8]\, PWDATA(7) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[7]\, PWDATA(6) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[6]\, PWDATA(5) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[5]\, PWDATA(4) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[4]\, PWDATA(3) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[3]\, PWDATA(2) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[2]\, PWDATA(1) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[1]\, PWDATA(0) => 
        \CoreAPB3_0_APBmslave15_PWDATA_[0]\, PRDATA(31) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[31]\, PRDATA(30) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[30]\, PRDATA(29) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[29]\, PRDATA(28) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[28]\, PRDATA(27) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[27]\, PRDATA(26) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[26]\, PRDATA(25) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[25]\, PRDATA(24) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[24]\, PRDATA(23) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[23]\, PRDATA(22) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[22]\, PRDATA(21) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[21]\, PRDATA(20) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[20]\, PRDATA(19) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[19]\, PRDATA(18) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[18]\, PRDATA(17) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[17]\, PRDATA(16) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[16]\, PRDATA(15) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[15]\, PRDATA(14) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[14]\, PRDATA(13) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[13]\, PRDATA(12) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[12]\, PRDATA(11) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[11]\, PRDATA(10) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[10]\, PRDATA(9) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[9]\, PRDATA(8) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[8]\, PRDATA(7) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[7]\, PRDATA(6) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[6]\, PRDATA(5) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[5]\, PRDATA(4) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[4]\, PRDATA(3) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[3]\, PRDATA(2) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[2]\, PRDATA(1) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[1]\, PRDATA(0) => 
        \CoreAPB3_0_APBmslave15_PRDATA_[0]\);
    

end DEF_ARCH; 
