----------------------------------------------------------------------
-- Created by Actel SmartDesign Thu Sep 23 11:07:32 2010
-- Testbench Template
-- This is a basic testbench that instantiates your design with basic 
-- clock and reset pins connected.  If your design has special
-- clock/reset or testbench driver requirements then you should 
-- copy this file and modify it. 
----------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity testbench is
end testbench;

architecture behavioral of testbench is

    constant SYSCLK_PERIOD : time := 100 ns;

    signal SYSCLK : std_logic := '0';
    signal NSYSRESET : std_logic := '0';

    component Top_MSS
        -- ports
        port( 
            -- Inputs
            MSSPREADY : in std_logic;
            MSSPSLVERR : in std_logic;
            CLR_ERR_603 : in std_logic;
            ENABLE_TRI_D_603 : in std_logic;
            ENABLE_TRI_E_603 : in std_logic;
            SENSE_HI_603 : in std_logic;
            SAMPLEx_603 : in std_logic;
            SCCLK_603 : in std_logic;
            SDI_262 : in std_logic;
            SCK_262 : in std_logic;
            ENN_262 : in std_logic;
            CLK_262 : in std_logic;
            CSN_262 : in std_logic;
            STEP_262 : in std_logic;
            DIR_262 : in std_logic;
            MSSPRDATA : in std_logic_vector(31 downto 0);
            UART_0_RXD : in std_logic;
            HallFX1_603 : in std_logic;
            SDO_262 : in std_logic;
            HallFX2_603 : in std_logic;
            VM262_FPGA : in std_logic;
            HallFX3_603 : in std_logic;
            CUR1_603 : in std_logic;
            CUR2_603 : in std_logic;
            CUR3_603 : in std_logic;
            VM603_FPGA : in std_logic;
            VAREF0 : in std_logic;
            VAREF1 : in std_logic;
            MSS_RESET_N : in std_logic;

            -- Outputs
            LVTTL_HALLFX1 : out std_logic;
            LVTTL_SDO_262 : out std_logic;
            LVTTL_HALLFX2 : out std_logic;
            LVTTL_HALLFX3 : out std_logic;
            FAB_CLK : out std_logic;
            MSSPSEL : out std_logic;
            MSSPENABLE : out std_logic;
            MSSPWRITE : out std_logic;
            OLED_DCN : out std_logic;
            M2F_RESET_N : out std_logic;
            MSSPADDR : out std_logic_vector(19 downto 0);
            MSSPWDATA : out std_logic_vector(31 downto 0);
            UART_0_TXD : out std_logic;
            MSSIO_1_DIR_262 : out std_logic;
            MSSIO_3_STEP_262 : out std_logic;
            MSSIO_5_CSN_262 : out std_logic;
            MSSIO_7_CLK_262 : out std_logic;
            MSSIO_8_ENN_262 : out std_logic;
            MSSIO_9_SCK_262 : out std_logic;
            MSSIO_10_SDI_262 : out std_logic;
            MSSIO_11_SCCLK_603 : out std_logic;
            MSSIO_12_SAMPLEx_603 : out std_logic;
            MSSIO_13_SENSE_HI_603 : out std_logic;
            MSSIO_14_ENABLE_TRI_603 : out std_logic;
            MSSIO_15_CLR_ERR_603 : out std_logic;

            -- Inouts
            I2C_0_SDA : inout std_logic;
            I2C_0_SCL : inout std_logic

        );
    end component;

begin

    process
        variable vhdl_initial : BOOLEAN := TRUE;

    begin
        if ( vhdl_initial ) then
            -- Assert Reset
            NSYSRESET <= '0';
            wait for ( SYSCLK_PERIOD * 10 );
            
            NSYSRESET <= '1';
            wait;
        end if;
    end process;

    -- 10MHz Clock Driver
    SYSCLK <= not SYSCLK after (SYSCLK_PERIOD / 2.0 );

    -- Instantiate Unit Under Test:  Top_MSS
    Top_MSS_0 : Top_MSS
        -- port map
        port map( 
            -- Inputs
            MSSPREADY => '0',
            MSSPSLVERR => '0',
            CLR_ERR_603 => '0',
            ENABLE_TRI_D_603 => '0',
            ENABLE_TRI_E_603 => '0',
            SENSE_HI_603 => '0',
            SAMPLEx_603 => '0',
            SCCLK_603 => SYSCLK,
            SDI_262 => '0',
            SCK_262 => '0',
            ENN_262 => '0',
            CLK_262 => SYSCLK,
            CSN_262 => '0',
            STEP_262 => '0',
            DIR_262 => '0',
            MSSPRDATA => (others=> '0'),
            UART_0_RXD => '0',
            HallFX1_603 => '0',
            SDO_262 => '0',
            HallFX2_603 => '0',
            VM262_FPGA => '0',
            HallFX3_603 => '0',
            CUR1_603 => '0',
            CUR2_603 => '0',
            CUR3_603 => '0',
            VM603_FPGA => '0',
            VAREF0 => '0',
            VAREF1 => '0',
            MSS_RESET_N => NSYSRESET,

            -- Outputs
            LVTTL_HALLFX1 =>  open,
            LVTTL_SDO_262 =>  open,
            LVTTL_HALLFX2 =>  open,
            LVTTL_HALLFX3 =>  open,
            FAB_CLK =>  open,
            MSSPSEL =>  open,
            MSSPENABLE =>  open,
            MSSPWRITE =>  open,
            OLED_DCN =>  open,
            M2F_RESET_N =>  open,
            MSSPADDR => open,
            MSSPWDATA => open,
            UART_0_TXD =>  open,
            MSSIO_1_DIR_262 =>  open,
            MSSIO_3_STEP_262 =>  open,
            MSSIO_5_CSN_262 =>  open,
            MSSIO_7_CLK_262 =>  open,
            MSSIO_8_ENN_262 =>  open,
            MSSIO_9_SCK_262 =>  open,
            MSSIO_10_SDI_262 =>  open,
            MSSIO_11_SCCLK_603 =>  open,
            MSSIO_12_SAMPLEx_603 =>  open,
            MSSIO_13_SENSE_HI_603 =>  open,
            MSSIO_14_ENABLE_TRI_603 =>  open,
            MSSIO_15_CLR_ERR_603 =>  open,

            -- Inouts
            I2C_0_SDA =>  open,
            I2C_0_SCL =>  open

        );

end behavioral;

