-------------------------------------------------------------------------------
--                                                                           --
-- File         : pwmcntl_uvw.vhd                                            --
--                                                                           --
-- Author(s)    : Dr. Lars Larsson (LL), www.trinamic.com                    --
--                                                                           --
-- Contributors :                                                            --
--                                                                           --
-- Description  : TMC60x commutator 'pwmcntl_uvw' block (from schematic)     --
--                                                                           --
-- Creation     : LL, July 24, 2008                                          --
--                                                                           --
-- History      : LL, February 6, 2010                                       --
--                                                                           --
-------------------------------------------------------------------------------
-- Hint(s)      :                                                            --
-------------------------------------------------------------------------------
--
-- Copyright (c) 2010, TRINAMIC Motion Control GmbH & Co. KG 
-- All rights reserved.
--
-- Redistribution and use in source and binary forms, with or without 
-- modification, are permitted provided that the following conditions 
-- are met:
--
-- Redistributions of source code must retain the above copyright notice, 
-- this list of conditions and the following disclaimer. Redistributions 
-- in binary form must reproduce the above copyright notice, this list of 
-- conditions and the following disclaimer in the documentation and/or 
-- other materials provided with the distribution. 
--
-- Neither the name of the TRINAMIC nor the names of its contributors may 
-- be used to endorse or promote products derived from this software without 
-- specific prior written permission. 
-- 
-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
-- AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
-- ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE 
-- LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
-- CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
-- SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
-- INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
-- CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
-- ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
-- THE POSSIBILITY OF SUCH DAMAGE.
--
-------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity pwmcntl_uvw is 
  port ( 
         BRAKE    :  in std_logic;
         PWM      :  in std_logic;
         HW, LW   :  in std_Logic;
         HV, LV   :  in std_Logic;
         HU, LU   :  in std_Logic;
         HTW, LTW : out std_Logic;
         HTV, LTV : out std_Logic;
         HTU, LTU : out std_Logic);
end pwmcntl_uvw;

architecture behavior of pwmcntl_uvw is

begin

  with BRAKE select HTW <= '0' when '1', HW  when others; 
  with BRAKE select HTV <= '0' when '1', HV  when others; 
  with BRAKE select HTU <= '0' when '1', HU  when others; 
                           
  with BRAKE select LTW <= LW  when '0', PWM when others; 
  with BRAKE select LTV <= LV  when '0', PWM when others; 
  with BRAKE select LTU <= LU  when '0', PWM when others;   
 
end behavior; 

---------------------------------------------------------------------------------------
